var joleraser_optionsDataBoolean        = new Array();
var joleraser_optionsDataInteger        = new Array();
var joleraser_optionsDataString         = new Array();

//Gre le changement des pages d'option
function changePage(pageList)
{
	storeOptions();
	
    document.getElementById("joleraser-options-iframe").setAttribute("src", pageList.selectedItem.value);
}

// Saves the user's options
function saveOptions()
{
    var parentWindow = null;
    var option       = null;
    var optionValue  = null;

    // Make sure current page is stored
    storeOptions();

    // Loop through the boolean options
    for(option in joleraser_optionsDataBoolean)
    {
        joleraser_setBooleanPreference(option, joleraser_optionsDataBoolean[option]);
    }

    // Loop through the integer options
    for(option in joleraser_optionsDataInteger)
    {
        optionValue = joleraser_optionsDataInteger[option];

        // If the option value is set
        if(optionValue)
        {
            joleraser_setIntegerPreference(option, optionValue);
        }
        else if(joleraser_isPreferenceSet(option))
        {
            joleraser_deletePreference(option);
        }
    }

    // Loop through the string options
    for(option in joleraser_optionsDataString)
    {
        optionValue = joleraser_optionsDataString[option];
        // If the option value is set or the preference currently has a value
        if(optionValue || joleraser_isPreferenceSet(option))
        {
            joleraser_setStringPreference(option, optionValue);
        }
    }
}

// Stores the user's options to be saved later
function storeOptions()
{
    var iFrame       = document.getElementById("joleraser-options-iframe");
    var iFrameSrc    = iFrame.getAttribute("src");
    var pageDocument = iFrame.contentDocument;

    if (iFrameSrc.indexOf("general") != -1)
    {
		//On vrifie que l'utilisateur a bien donn un entier comme identifiant
		var verif = /^\d*$/.test(pageDocument.getElementById("user_id").value);
		if (verif) //Si oui
		{
			joleraser_optionsDataInteger["joltool.user_id"]     = pageDocument.getElementById("user_id").value;
		}
    }
    else if (iFrameSrc.indexOf("afficher") != -1)
    {
		joleraser_optionsDataBoolean["joltool.afficher_menu_navigation_horizontal"]     = pageDocument.getElementById("afficher_menu_navigation_horizontal").checked;
    }
    else if (iFrameSrc.indexOf("masquer") != -1)
    {
		joleraser_optionsDataBoolean["joltool.masquer_barre_superieure"]	= pageDocument.getElementById("masquer_barre_superieure").checked;
		joleraser_optionsDataBoolean["joltool.masquer_banniere"]			= pageDocument.getElementById("masquer_banniere").checked;
		joleraser_optionsDataBoolean["joltool.masquer_barre_jol"]			= pageDocument.getElementById("masquer_barre_jol").checked;
		joleraser_optionsDataBoolean["joltool.masquer_annonces"]			= pageDocument.getElementById("masquer_annonces").checked;
		joleraser_optionsDataBoolean["joltool.masquer_publicites"]		= pageDocument.getElementById("masquer_publicites").checked;
		joleraser_optionsDataBoolean["joltool.masquer_actualites"]		= pageDocument.getElementById("masquer_actualites").checked;
		joleraser_optionsDataBoolean["joltool.masquer_licences"]			= pageDocument.getElementById("masquer_licences").checked;
		joleraser_optionsDataBoolean["joltool.masquer_sections_repliees"]	= pageDocument.getElementById("masquer_sections_repliees").checked;
		joleraser_optionsDataBoolean["joltool.masquer_sujets_fermes"]		= pageDocument.getElementById("masquer_sujets_fermes").checked;
		joleraser_optionsDataString["joltool.personnaliser_barre_jol"]	= save_barre_jol_option();
	}
	else if (iFrameSrc.indexOf("amis") != -1)
    {
		joleraser_optionsDataBoolean["joltool.use_friend_list"]     = pageDocument.getElementById("use_friend_list").checked;
    }
	else if (iFrameSrc.indexOf("ignores") != -1)
    {
		joleraser_optionsDataBoolean["joltool.use_foe_list"]     = pageDocument.getElementById("use_foe_list").checked;
    }
}

// Initializes the options dialog
function joleraser_initializeOptions()
{
	var selectedPage = document.getElementById("joleraser-page-list").selectedItem.value;

    // If this is the general page
    if(selectedPage.indexOf("general") != -1)
    {
        joleraser_initializeGeneral();
    }
    else if(selectedPage.indexOf("afficher") != -1)
    {
        joleraser_initializeAfficher();
    }
    else if(selectedPage.indexOf("masquer") != -1)
    {
        joleraser_initializeMasquer();
    }
	else if(selectedPage.indexOf("amis") != -1)
    {
		joleraser_initializeAmis();
    }
	else if(selectedPage.indexOf("ignores") != -1)
    {
		joleraser_initializeIgnores();
    }
}

// Initializes the general page
function joleraser_initializeGeneral()
{
    var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	//ID de l'utilisateur
	if(typeof joleraser_optionsDataInteger["joltool.user_id"] != "undefined")
    {
        pageDocument.getElementById("user_id").value = joleraser_optionsDataInteger["joltool.user_id"];
    }
    else if(joleraser_isPreferenceSet("joltool.user_id"))
    {
        pageDocument.getElementById("user_id").value = joleraser_getIntegerPreference("joltool.user_id", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("user_id").value = 0;
    }
}

// Initializes the afficher page
function joleraser_initializeAfficher()
{
    var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	//Menu de navigation horizontal
	if(typeof joleraser_optionsDataBoolean["joltool.afficher_menu_navigation_horizontal"] != "undefined")
    {
        pageDocument.getElementById("afficher_menu_navigation_horizontal").checked = joleraser_optionsDataBoolean["joltool.afficher_menu_navigation_horizontal"];
    }
    else if(joleraser_isPreferenceSet("joltool.afficher_menu_navigation_horizontal"))
    {
        pageDocument.getElementById("afficher_menu_navigation_horizontal").checked = joleraser_getBooleanPreference("joltool.afficher_menu_navigation_horizontal", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("afficher_menu_navigation_horizontal").checked = false;
    }
}

// Initializes the amis page
function joleraser_initializeAmis()
{
	joleraser_initializeList(1);
    var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	//Utilisation de la liste d'amis
	if(typeof joleraser_optionsDataBoolean["joltool.use_friend_list"] != "undefined")
    {
        pageDocument.getElementById("use_friend_list").checked = joleraser_optionsDataBoolean["joltool.use_friend_list"];
    }
    else if(joleraser_isPreferenceSet("joltool.use_friend_list"))
    {
        pageDocument.getElementById("use_friend_list").checked = joleraser_getBooleanPreference("joltool.use_friend_list", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("use_friend_list").checked = true;
    }
}

// Initializes the ignores page
function joleraser_initializeIgnores()
{
	joleraser_initializeList(0);
    var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	//Utilisations de la liste d'ignors
	if(typeof joleraser_optionsDataBoolean["joltool.use_foe_list"] != "undefined")
    {
        pageDocument.getElementById("use_foe_list").checked = joleraser_optionsDataBoolean["joltool.use_foe_list"];
    }
    else if(joleraser_isPreferenceSet("joltool.use_foe_list"))
    {
        pageDocument.getElementById("use_foe_list").checked = joleraser_getBooleanPreference("joltool.use_foe_list", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("use_foe_list").checked = true;
    }
}

// Initializes the masquer page
function joleraser_initializeMasquer()
{
    var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	//Masque d'affichage de la barre jol
	if(typeof joleraser_optionsDataString["joltool.personnaliser_barre_jol"] != "undefined")
    {
		populate_barre_jol_option(joleraser_optionsDataString["joltool.personnaliser_barre_jol"]);
    }
    else if(joleraser_isPreferenceSet("joltool.personnaliser_barre_jol"))
    {
		populate_barre_jol_option(joleraser_getStringPreference("joltool.personnaliser_barre_jol", true));
    }
    else //Dfaut
    {
		populate_barre_jol_option("0;0;1;1;0;1;0;0;0");
    }
	
	//Barre suprieure noire
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_barre_superieure"] != "undefined")
    {
        pageDocument.getElementById("masquer_barre_superieure").checked = joleraser_optionsDataBoolean["joltool.masquer_barre_superieure"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_barre_superieure"))
    {
        pageDocument.getElementById("masquer_barre_superieure").checked = joleraser_getBooleanPreference("joltool.masquer_barre_superieure", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_barre_superieure").checked = false;
    }
	
	//Bannire
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_banniere"] != "undefined")
    {
        pageDocument.getElementById("masquer_banniere").checked = joleraser_optionsDataBoolean["joltool.masquer_banniere"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_banniere"))
    {
        pageDocument.getElementById("masquer_banniere").checked = joleraser_getBooleanPreference("joltool.masquer_banniere", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_banniere").checked = true;
    }
	
	//Annonces
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_annonces"] != "undefined")
    {
        pageDocument.getElementById("masquer_annonces").checked = joleraser_optionsDataBoolean["joltool.masquer_annonces"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_annonces"))
    {
        pageDocument.getElementById("masquer_annonces").checked = joleraser_getBooleanPreference("joltool.masquer_annonces", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_annonces").checked = true;
    }
	
	//Barre jol
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_barre_jol"] != "undefined")
    {
        pageDocument.getElementById("masquer_barre_jol").checked = joleraser_optionsDataBoolean["joltool.masquer_barre_jol"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_barre_jol"))
    {
        pageDocument.getElementById("masquer_barre_jol").checked = joleraser_getBooleanPreference("joltool.masquer_barre_jol", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_barre_jol").checked = false;
    }
	
	//Publicit
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_publicites"] != "undefined")
    {
        pageDocument.getElementById("masquer_publicites").checked = joleraser_optionsDataBoolean["joltool.masquer_publicites"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_publicites"))
    {
        pageDocument.getElementById("masquer_publicites").checked = joleraser_getBooleanPreference("joltool.masquer_publicites", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_publicites").checked = false;
    }
	
	//Actualit
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_actualites"] != "undefined")
    {
        pageDocument.getElementById("masquer_actualites").checked = joleraser_optionsDataBoolean["joltool.masquer_actualites"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_actualites"))
    {
        pageDocument.getElementById("masquer_actualites").checked = joleraser_getBooleanPreference("joltool.masquer_actualites", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_actualites").checked = true;
    }
	
	//Licence
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_licences"] != "undefined")
    {
        pageDocument.getElementById("masquer_licences").checked = joleraser_optionsDataBoolean["joltool.masquer_licences"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_licences"))
    {
        pageDocument.getElementById("masquer_licences").checked = joleraser_getBooleanPreference("joltool.masquer_licences", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_licences").checked = true;
    }
	
	//Sections replies
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_sections_repliees"] != "undefined")
    {
        pageDocument.getElementById("masquer_sections_repliees").checked = joleraser_optionsDataBoolean["joltool.masquer_sections_repliees"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_sections_repliees"))
    {
        pageDocument.getElementById("masquer_sections_repliees").checked = joleraser_getBooleanPreference("joltool.masquer_sections_repliees", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_sections_repliees").checked = false;
    }
	
	//Sujets ferms
	if(typeof joleraser_optionsDataBoolean["joltool.masquer_sujets_fermes"] != "undefined")
    {
        pageDocument.getElementById("masquer_sujets_fermes").checked = joleraser_optionsDataBoolean["joltool.masquer_sujets_fermes"];
    }
    else if(joleraser_isPreferenceSet("joltool.masquer_sujets_fermes"))
    {
        pageDocument.getElementById("masquer_sujets_fermes").checked = joleraser_getBooleanPreference("joltool.masquer_sujets_fermes", true);
    }
    else //Dfaut
    {
        pageDocument.getElementById("masquer_sujets_fermes").checked = false;
    }
}

function populate_barre_jol_option(aString)
{
	var optionTab = aString.split(";");
	var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	if (optionTab[0] == "1") { pageDocument.getElementById("barre_compte").checked = true; }
	if (optionTab[1] == "1") { pageDocument.getElementById("barre_membres").checked = true; }
	if (optionTab[2] == "1") { pageDocument.getElementById("barre_guildes").checked = true; }
	if (optionTab[3] == "1") { pageDocument.getElementById("barre_photos").checked = true; }
	if (optionTab[4] == "1") { pageDocument.getElementById("barre_recherche").checked = true; }
	if (optionTab[5] == "1") { pageDocument.getElementById("barre_boutique").checked = true; }
	if (optionTab[6] == "1") { pageDocument.getElementById("barre_aide").checked = true; }
	if (optionTab[7] == "1") { pageDocument.getElementById("barre_liens").checked = true; }
	if (optionTab[8] == "1") { pageDocument.getElementById("barre_deconnexion").checked = true; }
	
	return true;
}

function save_barre_jol_option()
{
	var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	var aString = "";
	
	if (pageDocument.getElementById("barre_compte").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_membres").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_guildes").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_photos").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_recherche").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_boutique").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_aide").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_liens").checked) { aString += "1;"; } else { aString += "0;"; }
	if (pageDocument.getElementById("barre_deconnexion").checked) { aString += "1"; } else { aString += "0"; }
	
	return aString;
}

function enable_barre_jol_option()
{
	var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	pageDocument.getElementById("barre_compte").disabled		= false;
	pageDocument.getElementById("barre_membres").disabled		= false;
	pageDocument.getElementById("barre_guildes").disabled		= false;
	pageDocument.getElementById("barre_photos").disabled		= false;
	pageDocument.getElementById("barre_recherche").disabled		= false;
	pageDocument.getElementById("barre_boutique").disabled		= false;
	pageDocument.getElementById("barre_aide").disabled			= false;
	pageDocument.getElementById("barre_liens").disabled			= false;
	pageDocument.getElementById("barre_deconnexion").disabled	= false;
	
	return true;
}

function disable_barre_jol_option()
{
	var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	
	pageDocument.getElementById("barre_compte").disabled		= true;
	pageDocument.getElementById("barre_membres").disabled		= true;
	pageDocument.getElementById("barre_guildes").disabled		= true;
	pageDocument.getElementById("barre_photos").disabled		= true;
	pageDocument.getElementById("barre_recherche").disabled		= true;
	pageDocument.getElementById("barre_boutique").disabled		= true;
	pageDocument.getElementById("barre_aide").disabled			= true;
	pageDocument.getElementById("barre_liens").disabled			= true;
	pageDocument.getElementById("barre_deconnexion").disabled	= true;
	
	return true;
}

function joleraser_initializeList(index) //1 : amis ; 0 : ignor
{
	var pageDocument = document.getElementById("joleraser-options-iframe").contentDocument;
	var listBox    = pageDocument.getElementById("joleraser-listbox");
	
	if (index == 1)
	{
		if (joleraser_isPreferenceSet("joltool.friend-list"))
		{
			var work_list = joleraser_getStringPreference("joltool.friend-list", true)
		} else { var work_list = "" }
	} else
	{
		if (joleraser_isPreferenceSet("joltool.foe-list"))
		{
			var work_list = joleraser_getStringPreference("joltool.foe-list", true)
		} else { var work_list = "" }
	}
	
	var prefTab = work_list.split(";;;");
	
	for (var i = 0 ; i<prefTab.length ; i++)
	{
		var list_info = prefTab[i].split(";;");
		if (list_info.length == 2)
		{
			var pseudo     = pageDocument.createElement("listcell");
			pseudo.setAttribute("label", list_info[0]);
			var id     = pageDocument.createElement("listcell");
			id.setAttribute("label", list_info[1]);
			var listItem     = pageDocument.createElement("listitem");
			listItem.appendChild(pseudo);
			listItem.appendChild(id);
		
			listBox.selectItem(listBox.appendChild(listItem));
	        listBox.ensureElementIsVisible(listBox.selectedItem);
		}
	}
	
	return true;
}

function joleraser_addList(index) //1 : amis ; 0 : ignor
{
	var pageDocument	= document.getElementById("joleraser-options-iframe").contentDocument;
	var listBox			= pageDocument.getElementById("joleraser-listbox");
	var pseudo			= pageDocument.getElementById("joleraser-add-pseudo").value;
	var id				= pageDocument.getElementById("joleraser-add-id").value;
	
	//On vrifie que l'identifiant est bien un nombre
	var verif = /^\d*$/.test(id);
	if (!verif) //Si oui
	{
		alert("L'identifiant donn n'est pas valide.");
		return false;
	}
	//On vrifie que le pseudo donn n'est pas vide
	if (pseudo == "")
	{
		alert("Le pseudo donn est vide.");
		return false;
	}
	//On rcupre la liste
	if (index == 1)
	{
		if (joleraser_isPreferenceSet("joltool.friend-list"))
		{
			var work_list = joleraser_getStringPreference("joltool.friend-list", true)
		} else { var work_list = "" }
	} else
	{
		if (joleraser_isPreferenceSet("joltool.foe-list"))
		{
			var work_list = joleraser_getStringPreference("joltool.foe-list", true)
		} else { var work_list = "" }
	}

	if (work_list.indexOf(";" + id + ";") != -1)
	{
		alert("Cet identifiant est dj dans votre liste. Si vous voulez modifier son pseudo, supprimez le d'abord.");
		return false;
	}

	if (index == 1)
	{
		joleraser_setStringPreference("joltool.friend-list", work_list + pseudo + ";;" + id + ";;;");
	} else
	{
		joleraser_setStringPreference("joltool.foe-list", work_list + pseudo + ";;" + id + ";;;");
	}

	var pseudo_element     = pageDocument.createElement("listcell");
	pseudo_element.setAttribute("label", pseudo);
	var id_element     = pageDocument.createElement("listcell");
	id_element.setAttribute("label", id);
	var listItem     = pageDocument.createElement("listitem");
	listItem.appendChild(pseudo_element);
	listItem.appendChild(id_element);
	listBox.selectItem(listBox.appendChild(listItem));
	listBox.ensureElementIsVisible(listBox.selectedItem);
	//Fin
	return true;
}

function joleraser_deleteList(index) //1 : amis ; 0 : ignor
{
	var pageDocument	= document.getElementById("joleraser-options-iframe").contentDocument;
	var listBox			= pageDocument.getElementById("joleraser-listbox");
    var selectedItem	= listBox.selectedItem;
	//On rcupre la liste
	if (index == 1)
	{
		if (joleraser_isPreferenceSet("joltool.friend-list"))
		{
			var work_list = joleraser_getStringPreference("joltool.friend-list", true)
		} else { var work_list = "" }
	} else
	{
		if (joleraser_isPreferenceSet("joltool.foe-list"))
		{
			var work_list = joleraser_getStringPreference("joltool.foe-list", true)
		} else { var work_list = "" }
	}
	
	 if(selectedItem)
    {
		var pseudo = selectedItem.childNodes[0].getAttribute("label");
		var id = selectedItem.childNodes[1].getAttribute("label");
        listBox.removeChild(selectedItem);
		
		if (index == 1)
		{
			joleraser_setStringPreference("joltool.friend-list", work_list.replace(pseudo + ";;" + id + ";;;", ""));
		} else
		{
			joleraser_setStringPreference("joltool.foe-list", work_list.replace(pseudo + ";;" + id + ";;;", ""));
		}
    }
	return true;
}